;   LC-    
;  ATtiny2313-10PI.    Fo=10'000'000 .
;
;        
; Cx=COEFF_C*[nx*No/no*Nx-1], 
; Ro-    ,    
; Co-    ,    
; nx-   Fo,      Nx   ,
;  (Cx+Co)*Ro
; no-   Fo,      Nx   ,
;  Ro*Co  

;   L     
; Lx=COEFF_L*[(nx*No/no*Nx)^2-1]
;  nx-      (Fo)    Nx
; no-   Fo    No
; Nx-            
; No-            

; 

;   "0".      no, No   
;   "0.00",  "0" .
;       "x"    .
;       "Lx"  .

;   RAM
; $68-    100
; $69-     10
; $6A-      1
; $6B-      

; $6C-    
; $6E- KEY
; $6F-      

; $76...$79  nx
; $86...$89  Nx
;***************************************************************************
;     
;PB1- A
;PB0- B
;PB6- C
;PB4- D
;PB3- E
;PB2- F
;PB7- G
;PB5- H

;PD5- 
;PD2- 1
;PD3- 10
;PD4- 100
;  

;PD0- ">0<"
;PD1- "C/L"

;ICP- ICP

;PA0...PA4 -   24
;5...7 -   7
;
;PC0...PC2 -   LED (/,/,/)
;PC3,4 -   MODE ()
;PC5   -   
;PC6,7 -     7  24



;***************************************************************************
; 27.01.2012
; 21.05.2010
; 18.02.2010
; 24/04/2013  	 6. 	   2313  8515 ( YH ZH)
;							  ,. 
;							/ OUT_PORT_AC    A 3-    Rx.
;						  , 
;				 7.	/ BAND_E24  5-    Rx   24
;							    / OUT_PORT_AC   
;						  ,  (24.04.2013)
;		 8.	       (). OK
;					     . OK ,    , -,  
;																    ,  .OK

;		 9												
;					     24. 	,  . OK
;					   LED   ( 7, 24). , 6  7   ,  .
;					  LED  .  . OK
;					      !

;		 10	    .    :											
;					1.      .
;					2. - DIAP123  .   1  3,  3  1  
;						 INDEX_DEC_POINT.  .

;		 11	  :											
;					1.    7  9528 ( 9995). OK
;					2.   7, 24     OK
;					3.     Rx    	 DIAP_123. OK	
;					
;;		 12	:											

;				 DIP-    ( 0...3)
;				     3,4 (3-,4-) OK	
;				     ".0"    4
;				       OK	
;				1.  0 -     7,24 (3,4=00).( 11 _OK_no_verify)   OK
;					
;				2.  4 (VERIFY_Rx)-  7, 24 (3 )  .  .   
;					
;				3.  1,2,3       4    
;							
				
;					





	.INCLUDE "8515def.inc"	;+++++++++++++++++++++++++++++++

	.def	A	=r16
	.def	B	=r17
	.def	H	=r18
	.def	L	=r19
	.def	D	=r20
	.def	E	=r21
	.def	F	=r22
	.def	G	=r23
	.def	J	=r24
	.def	K	=r25

	.equ	DCLK	=0
	.equ	DOUT	=1
	
	.equ	DIAPAZON=$7F
	.equ	RAM_PEREGRUZKA=$7E

	.equ	DIAP_123=$7A		;++++++++++++++++++ 25/04/2013
	.equ	MODE=$7B			;    (0...3)%%%%%%%%%%%%%%%%%%13
	.equ	DIAPAZON_E7=$7D		;++++++++++++++++++
	.equ	DIAPAZON_E24=$7C	;++++++++++++++++++
	


	.equ	DD_123=$A0		;      %%%%%%%%%%%%%%%%%%13
	.equ	RS1=$A1			;     Rx %%%%%%%%%%%%%%%%%%13
	.equ	RS2=$A2			;     Rx %%%%%%%%%%%%%%%%%%13
	.equ	RS3=$A3			;     Rx %%%%%%%%%%%%%%%%%%13
	.equ	DS_E7=$A4		;     7 %%%%%%%%%%%%%%%%%%13
	.equ	DS_E24=$A5		;     24 %%%%%%%%%%%%%%%%%%13
	.equ	N_VER=$A6		;      verify_Mode %%%%%%%%%%%%%%%%%%13
	
	.equ	V_OK=$A7		;   verify_OK=1 %%%%%%%%%%%%%%%%%%13
	.equ	V_LED=$A8		;    LED=1  %%%%%%%%%%%%%%%%%%13
	.equ	ZUMM=$A9		;    =1 %%%%%%%%%%%%%%%%%%13
	.equ	RAZM=$AA		;    =1 %%%%%%%%%%%%%%%%%%13


	.equ	ANODE	=$6F
	.equ	KEY	=$6E
	.equ	MINUS	=$6C
	
	.equ	INDR	=$6B
	.equ	IND1	=$6A
	.equ	IND10	=$69
	.equ	IND100	=$68
;************************************************
; 27.01.2012
	.equ	REGIM	=$66
;************************************************
	.equ	RAM_COEFF_C	=$90
	.equ	RAM_CONST_C	=$94
	.equ	RAM_COEFF_R	=$98
	.equ	RAM_CONST_R	=$9C
	.equ	RAM_E24		=$100	; +++++++++++++++++  

	.ESEG
	.ORG	$50
;***************************************************************************
; ,     Ro=2030 m Co=6080 pF
;***************************************************************************
COEFF_C:
	.DB	$00,$4B,$BA,$F6		; Co*1000*K
E_CONST_C:
	.DB	$02,$0A,$F6,$41		;65536*65536*No/no 020AF084 $02,$0A,$7C,$B0
					;
;***************************************************************************
; ,     Ro=2000 om Co=6080 pF
;***************************************************************************
COEFF_R:
	.DB	$00,$03,$57,$86		;
E_CONST_R:
	.DB	$01,$DE,$C1,$AE		;65536*65536*No/no 01DECFCB $01,$DD,$94,$39
E_END:
;************************************************
	.CSEG
	
	.ORG	$00
RESET:
	RJMP	START		; On Reset
	SET			; On Interrupt 0
	RETI			; On Interrupt 1

	RJMP	CAPT		; Timer 1 capture
	RJMP	TIMER_COMP1	; Timer 1A compare
;***************************************************************************
	nop 		;  8515 ++++++++++++++++++++++++++++++++++
;24.05.2010
	
	ADIW	XL,1	;  1
	CPI	XH,10	; , (  ~16.8 ) 
	BRCS	IZM	;        

	SET		;     -  T -    
IZM:
	RETI
;***************************************************************************
DC_ANODE:
	.DB	$53,$4B,$47,$63     ;     
TTB_IND:
	.DB	$A0,$BE	; 0,1   ;     
	.DB	$64,$2C	; 2,3
	.DB	$3A,$29	; 4,5
	.DB	$21,$BC	; 6,7
	.DB	$20,$28	; 8,9
;	.DB	$70,$F8	; p,n
;	.DB	$72,$FF	; u,

;***************************************************************************
START:
	LDI	R16,LOW(RAMEND)
	OUT	SPL,R16
	ldi	R16,HIGH(RAMEND)	;	++++++++++++++++++++++++++++++++
	out	SPH,R16				;	++++++++++++++++++++++++++++++++

	LDI	R20,0b11111111
	OUT	DDRB,R20	;
	OUT	PORTB,R20

; ++++++   A           (5 ) 

	out	DDRA,R20		;   
	LDI	R20,0b11100111	; 
	out	DDRC,R20		;3,4 - ,  - 	

	ldi	R20,0b00000000	;
	out	PORTA,R20		;
	
	ldi	R20,0b00011000	;									%%%%%%%%%%%%%%%
	out	PORTC,R20		;    		%%%%%%%%%%%%%%%

; ++++++++++++++++++++++++++++++   ,  

	
	
	LDI	R20,0b00111100	;     D
	OUT	DDRD,R20	;
	LDI	R20,0b11000011
	OUT	PORTD,R20

	CLR	ZH	
	LDI	ZL,$60
	RCALL	CLEAR_R64

	ldi	ZL,$A0
	rcall	CLEAR_R10	;   ,  

	ldi R20,1
	sts V_OK,R20		;   V_OK=1

; %%%%%%%%%%%%%%%%%%%%%%%%% ,   ? %%%%%%%%%%%%%%%%%
	in	R19,PIND
	sbrc R19,0	;  ,   
	rjmp no_push
	ldi R20,4
	sts MODE,R20
	ldi R19,0b00111010 	;   4  
	rjmp mode_n			;    ( )

no_push:		;     (MODE)   DIP- (3,4) 
	clr R20
	in	R19,PINC
	bst R19,3	;      
	bld	R20,0	;         3 (), 
	bst R19,4	; 4 - ()
	bld	R20,1	;  R20     (0...3) 
	com R20
	andi R20, 0b00000011
	sts MODE,R20	;    
	
;           
	lds R20,MODE
	cpi R20,0
	breq mode_0
	cpi R20,1
	breq mode_1
	cpi R20,2
	breq mode_2
	cpi R20,3
	breq mode_3

mode_1:
	ldi R19,0b10111110
	rjmp mode_n
mode_2:
	ldi R19,0b01100100
	rjmp mode_n
mode_3:
	ldi R19,0b00101100
	rjmp mode_n
mode_0:
	ldi R19,0b10000000
mode_n:
	LDI	R20,0b01111111
	sts IND100,R19	;   STS	IND100,R20
	STS	IND10,R20
	STS	IND1,R20
	LDI	R20,$77		; "r"
	SBIC	PIND,1
	LDI	R20,$E1		; "C"
	STS	INDR,R20	;     "C/r"

;***************************************************************************

; ++++++++++++++++++++    LED (E7,E24,123) ++++++++++++++++++++++++++++
	rcall TEST_LED	;   
;	rcall BEEP_ON
;	rcall DELAY_025s
;	rcall BEEP_OFF
;		rcall DELAY_01s
;	rcall BEEP_ON
;	rcall DELAY_025s
;	rcall BEEP_OFF
;		rcall DELAY_01s
	rcall BEEP_ON
	rcall DELAY_01s
	rcall BEEP_OFF

; +++++++++++++++++++++++++++   LED ++++++++++++++++++++++++

	IN	R20,PIND
	ANDI	R20,$02		;     (Rx/Cx)
	STS	REGIM,R20		; REGIM: $02-Cx,  $00-Rx

;***************************************************************************
	
	clr ZH		;	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>	ok
	clr YH		;	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>	ok
	
	LDI	ZL,LOW(COEFF_C)
	LDI	YL,LOW(COEFF_C+$40)
RAM_E:
	RCALL	EEREAD
	ST	Y,R0
	INC	YL
	INC	ZL
	CPI	ZL,LOW(E_END)
	BRNE	RAM_E
;*********************************************************************   * 
;*********************************************************************   * 
;*********************************************************************   *  
;*********************************************************************   *  
;********************************************************************  *****
;*********************************************************************  ***
;**********************************************************************  *

SCHIT:
	CLI
	CLR	ZH

	LDI	A,$80
	OUT	ACSR,A		; OFF ANALOG COMP
	
	STS	MINUS,ZH
	STS	RAM_PEREGRUZKA,ZH
	STS	ANODE,ZH

	LDI	R16,$23		;   INT0,   
	OUT	MCUCR,R16	;  

	OUT	TCCR1B,ZH
	OUT	TCNT1H,ZH
	OUT	TCNT1L,ZH

	LDI	R18,HIGH(16433)
	OUT	OCR1AH,R18

	LDI	R19,LOW(16433)
	OUT	OCR1AL,R19

	LDI	R20,$40
	OUT	TIMSK,R20	;  OCR1A
	OUT	GIMSK,R20	;  INT0

	SER	R20		
	OUT	TIFR,R20	;  FLAG
	OUT	GIFR,R20

	LDI	R20,$01		;   1
	OUT	TCCR1B,R20

	CLT
	SEI
WAIT_BEGIN_IND:
;	SLEEP
	BRTC	WAIT_BEGIN_IND
;***************************************************************************
;        
;***************************************************************************
	CLI
	CLT
;		    

	SBIS	PIND,0
	RJMP	CALIBROVKA
	SBIS	PIND,1
	RCALL	RESULT_Rx
	SBIC	PIND,1
	RCALL	RESULT_Cx
RES_GO:
;***************************************************************************
	LDS	R20,RAM_PEREGRUZKA
	TST	R20
	BRNE	PEREGRUZKA
;***************************************************************************
	RCALL	BAND
	LDS	R20,DIAPAZON
	CPI	R20,11			; ,    (  10 )?
	BRCS	RES_G01
PEREGRUZKA:	
	LDI	R20,$FD
	STS	IND100,R20
	STS	IND10,R20
	STS	IND1,R20
	LDI	R20,$77		; "r"
	SBIC	PIND,1
	LDI	R20,$E1		; "C"
	STS	INDR,R20	;     "C/r"
;+++++++++++++
	ldi R20, 0b11111000 ;   V , .   . ( ldi R20, 0b11000000)
	out PORTC,R20		;         7,24
;++++++++++++++



	RJMP	SCHIT
;************************************************* 

RES_G01:     	;  ,   .   Rx/Cx .
	
;++++++++++++    7  24	   
	rcall 	BAND_E24
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	rcall 	VERIFY
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	rcall 	OUT_PORT_A	;   PORTA  7  24

	RCALL	BIN_BCD
	RCALL	CODIR
	RCALL	INDEX_DEC_POINT
	
	rcall 	D123
	rcall 	OUT_PORT_C


xxRES_GO3:
	LDS	R20,MINUS
	TST	R20
	BRPL	PLUS
	CBR	R19,$20		;   $80 -     
PLUS:
	STS	IND100,R16
	STS	IND10,R17
	STS	IND1,R18
	STS	INDR,R19

	RJMP	SCHIT
;**********************************************************************  * 
;*********************************************************************  *** 
;********************************************************************  *****
;********************************************************************    *
;********************************************************************    * 
;********************************************************************    * 
;********************************************************************    * 
RESULT_Rx:
	RCALL	RABOTA
RESULT_Rx_CAL:
	
	LDI	ZL,$0A
	RCALL	CLEAR_R10	;   R10...R19
	
	LDI	ZL,LOW(RAM_CONST_R)
	LD	R16,Z+
	LD	R17,Z+
	LD	R18,Z+
	LD	R19,Z
	
	RCALL	RES_nox		;  nx
	
	RCALL	MULT		; (65536*65536*No/no)*nx
	
	RCALL	RES_Nx		;  Nx

	RCALL	DIV		; [(65536*65536*No/no)*nx]/Nx
;***************************************************************************
	LDI	R20,1

	SUB	R5,R20
	SBC	R4,ZH
	SBC	R3,ZH
	SBC	R2,ZH
	SBC	R1,ZH
	SBC	R0,ZH		; [(65536*65536*No/no)*(nx/Nx)]-1 0000 0000
	
	TST	R0
	BRPL	RES_Rx01
	
	LDI	R20,$80
	STS	MINUS,R20

	RCALL	CONV	
RES_Rx01:
;***************************************************************************

	LDI	ZL,$0A
	RCALL	CLEAR_R10	;     

	LDI	ZL,LOW(RAM_COEFF_R)
	
	LD	R16,Z+
	LD	R17,Z+
	LD	R18,Z+
	LD	R19,Z

	RCALL	MULT	

	MOV	R9,R5
	MOV	R8,R4
	MOV	R7,R3
	MOV	R6,R2
	MOV	R5,R1
	MOV	R4,R0
	CLR	R3
	CLR	R2
	CLR	R1
	CLR	R0
		;      
	RET
;************************************************
RESULT_Cx:
	RCALL	RABOTA
RESULT_Cx_CAL:
	
	LDI	ZL,$0A
	RCALL	CLEAR_R10	;   R10...R19
	
	LDI	ZL,LOW(RAM_CONST_C)
	LD	R16,Z+
	LD	R17,Z+
	LD	R18,Z+
	LD	R19,Z
	
	RCALL	RES_nox		;  nx
	
	RCALL	MULT		; (65536*65536*No/no)*nx
	
	RCALL	RES_Nx		;  Nx

	RCALL	DIV		; [(65536*65536*No/no)*nx]/Nx
;***************************************************************************
	LDI	R20,1

	SUB	R5,R20
	SBC	R4,ZH
	SBC	R3,ZH
	SBC	R2,ZH
	SBC	R1,ZH
	SBC	R0,ZH		; [(65536*65536*No/no)*(nx/Nx)]-1 0000 0000
	
	TST	R0
	BRPL	RES_Cx01
	
	LDI	R20,$80
	STS	MINUS,R20

	RCALL	CONV	
RES_Cx01:
;***************************************************************************

	LDI	ZL,$0A
	RCALL	CLEAR_R10	;     

	LDI	ZL,LOW(RAM_COEFF_C)
	
	LD	R16,Z+
	LD	R17,Z+
	LD	R18,Z+
	LD	R19,Z

	RCALL	MULT	

	MOV	R9,R5
	MOV	R8,R4
	MOV	R7,R3
	MOV	R6,R2
	MOV	R5,R1
	MOV	R4,R0
	CLR	R3
	CLR	R2
	CLR	R1
	CLR	R0
		;      
	RET
;***************************************************************************
CALIBROVKA:
	SBIC	PIND,1
	RJMP	CALIBROVKA_C
CALIBROVKA_R:
;***************************************************************************
;   N  n   No  no
;65536*65536*No/no
;***************************************************************************
	RCALL	RABOTA
	
	LDI	R21,20
	
	LDI	ZL,$00
	RCALL	CLEAR0		;   R0...R19
	
	LDS	R2,$86
	LDS	R3,$87
	LDS	R4,$88
	LDS	R5,$89		;  N*65536^2
	
	LDS	R16,$76
	LDS	R17,$77
	LDS	R18,$78
	LDS	R19,$79		;  n
	
	RCALL	DIV

	STS	RAM_CONST_R+0,R6
	STS	RAM_CONST_R+1,R7
	STS	RAM_CONST_R+2,R8
	STS	RAM_CONST_R+3,R9

	RCALL	RESULT_Rx_CAL
;***************************************************************************
;      EEPROM	
	RCALL	SAVE
	RJMP	RES_GO
;***************************************************************************
CALIBROVKA_C:
;65536*65536*No/no
	RCALL	RABOTA

	LDI	R21,20

	LDI	ZL,$00
	RCALL	CLEAR0		;   R0...R19

	LDS	R2,$86
	LDS	R3,$87
	LDS	R4,$88
	LDS	R5,$89		;  N*65536^2
	
	LDS	R16,$76
	LDS	R17,$77
	LDS	R18,$78
	LDS	R19,$79		; ; nx

	RCALL	DIV
	
	STS	RAM_CONST_C+0,R6
	STS	RAM_CONST_C+1,R7
	STS	RAM_CONST_C+2,R8
	STS	RAM_CONST_C+3,R9

	RCALL	RESULT_Cx_CAL
;      EEPROM	
	RCALL	SAVE
	RJMP	RES_GO
;***************************************************************************
;     
;	   4      ++++++++++++++++++++++++++++

INDEX_DEC_POINT:
	
	push R22
	push R23

	MOV	R20,R19		;    
	LDS	R21,DIAPAZON
	CPI	R21,1
	BRNE	IDP2
	CBR	R16,$20		; x.xx
	LDI	R19,$70		; x.xxpF
	ldi R23,3		;      123 +++++++++++++ 25/04/2013

	RJMP	IDP_OUT
IDP2:
	CPI	R21,2
	BRNE	IDP3
	CBR	R17,$20		; xx.x
	LDI	R19,$70		; xx.xpF
	ldi R23,3		;      123 +++++++++++++ 25/04/2013

	RJMP	IDP_OUT
IDP3:
	CPI	R21,3
	BRNE	IDP4
	LDI	R19,$70		; xxxpF
	ldi R23,3		;      123 +++++++++++++ 25/04/2013

	sbic	PIND,1
	rjmp	IDP4
	cbr	R17,$20		; x.xxx
	mov R19,R20		;    

	RJMP	IDP_OUT
IDP4:
	CPI	R21,4
	BRNE	IDP5
	mov R22,R16		;    
	CBR	R16,$20		; x.xx
	LDI	R19,$F8		; x.xxn
	ldi R23,2		;      123 +++++++++++++ 25/04/2013

	SBIC	PIND,1
	RJMP	IDP5

;	LDI	R19,$72		; x.xxuH
	cbr	R17,$20		; xx.xx
	mov R16,R22		;    
	mov R19,R20		;    
	ldi R23,3		;      123 +++++++++++++ 25/04/2013
	
	RJMP	IDP_OUT
IDP5:
	CPI	R21,5
	BRNE	IDP6
	mov R22,R17		;    
	CBR	R17,$20		; xx.x
	LDI	R19,$F8		; xx.xnF
	ldi R23,2		;      123 +++++++++++++ 25/04/2013

	SBIC	PIND,1
	RJMP	IDP6

;	LDI	R19,$72		; xx.xuH
	cbr	R18,$20		; xxx.x
	mov R17,R22		;    
	mov R19,R20		;    
	ldi R23,3			;      123 +++++++++++++ 25/04/2013

	RJMP	IDP_OUT
IDP6:
	CPI	R21,6
	BRNE	IDP7
	LDI	R19,$F8		; xxxnF
	ldi R23,2		;      123 +++++++++++++ 25/04/2013

	SBIC	PIND,1
	RJMP	IDP7
		
	mov R19,R20		;    
	cbr	R16,$20		; x.xxx   
;	LDI	R19,$72		; xxxuH

	ldi R23,2			;      123 +++++++++++++ 25/04/2013

	RJMP	IDP_OUT
IDP7:
	CPI	R21,7
	BRNE	IDP8
	mov R22,R16		;    
	CBR	R16,$20		; x.xx
	LDI	R19,$72		; x.xxuF
	ldi R23,1		;      123 +++++++++++++ 25/04/2013

	SBIC	PIND,1
	RJMP	IDP8
	
	mov R16,R22		;    
	mov R19,R20		;     
	cbr	R17,$20		; xx.xx    
;	MOV	R19,R20		; x.xxx(mH)
	ldi R23,2		;      123 +++++++++++++ 25/04/2013

	RJMP	IDP_OUT
IDP8:
	CPI	R21,8
	BRNE	IDP9
	mov R22,R17		;    
	CBR	R17,$20		; xx.x
	LDI	R19,$72		; xx.xuF
	ldi R23,1		;      123 +++++++++++++ 25/04/2013

	SBIC	PIND,1
	RJMP	IDP9
	
	mov R17,R22		;    
	mov R19,R20		;     
	cbr	R18,$20		; xxx.x    
;	MOV	R19,R20		; xx.xx(mH)
	ldi R23,2		;      123 +++++++++++++ 25/04/2013

	RJMP	IDP_OUT
IDP9:
	CPI	R21,9
	BRNE	IDP10
	LDI	R19,$72		; xxxuF
	ldi R23,1		;      123 +++++++++++++ 25/04/2013


	SBIC	PIND,1
	RJMP	IDP10

	mov R19,R20		;     
	cbr	R16,$20		; x.xxx    

	ldi R23,1		;      123 +++++++++++++ 25/04/2013

;	CBR	R18,$20
;	MOV	R19,R20		; xxx.x(mH)
	RJMP	IDP_OUT

IDP10:
	CPI	R21,10
	BRNE	IDP_OUT

;	LDI	R19,$72		; xxxx(uF)
	ldi R19,$20		; .
	ldi R23,1		;      123 +++++++++++++ 25/04/2013

	SBIC	PIND,1
	RJMP	IDP_OUT
;	MOV	R19,R20
;	LDI	R19,$8D		; xxxx(mH)
	
	cbr	R17,$20		; xx.xx    
	ldi R23,1		;      123 +++++++++++++ 25/04/2013

IDP_OUT:

		
	sts DIAP_123,R23	;      123 +++++++++++++ 25/04/2013
	
	pop R23
	pop R22
	
	RET
	
;  

D123:
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; +++++    DD_123   
; +++++    OK     ( ) +++++++++++++
	push R22
	push R23
	push R24
	
	
	clr R22				;  
	ldi R23,0b00001000	;     
	lds R24, DIAP_123	
D_123:
	lsr R23				;    
	inc R22
	cpse R22, R24
	rjmp D_123 			; ,  

	sts DD_123, R23

	pop R24
	pop R23
	pop R22

	ret
; ++++ 	  DD_123    3     
; +++++++++++++++++++++++++++   DIAP_123 +++++++++++++++++++++++++++
; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
;*************************************************
RES_Nx:
	LDI	ZL,$80

	LDI	YH,$00
	LDI	YL,$0A

	RJMP	GND_SET
;*************************************************
RES_nox:
	LDI	ZL,$70
	
	LDI	YH,$00
	LDI	YL,$00
GND_SET:
	LDI	R20,10
SET_RAM:
	LD	R21,Z+
	ST	Y+,R21
	DEC	R20
	BRNE	SET_RAM
	RET
;************************************************
SAVE:
	PUSH	R0
	PUSH	A

	LDI	ZL,LOW(COEFF_C)
	CLR	YH
	LDI	YL,LOW(RAM_COEFF_C)
E_RAM:
	RCALL	EEREAD
	LD	A,Y
	CPSE	A,R0
	RCALL	R0_A
	INC	YL
	INC	ZL
	CPI	ZL,LOW(E_END)
	BRNE	E_RAM
	POP	A
	POP	R0
	RET
R0_A:
	MOV	R0,A
;************************************************
;   EEPROM
; ZH,ZL -
; R0- 
;************************************************
EEWRITE:
	SBIC	EECR,EEWE
	RJMP	EEWRITE

	out     EEARH,ZH	; +++++++++++++++++	
	OUT     EEARL,ZL
	OUT     EEDR,R0

	SBI     EECR,EEMWE
	SBI     EECR,EEWE
EEWWAIT:
	SBIC    EECR,EEWE
	RJMP    EEWWAIT

	RET
;************************************************
;   EEPROM
; ZH,ZL-
; R0-
;************************************************
EEREAD:
	
	out     EEARH,ZH	; ++++++++++++++++++
	OUT     EEARL,ZL
	SBI     EECR,EERE

	IN      R0,EEDR

	RET
;************************************************
CODIR:

	LDI	ZL,$0A
	RCALL	CLEAR_R10	;   
	
	LDI	R25,4
COD:
	RCALL	SDVIG_4
	LDI	ZL,LOW (TTB_IND*2)
	ADD	ZL,R7
	LPM
	RCALL	SDVIG_8
	
	DEC	R25
	BRNE	COD
	
	RET
;************************************************
SDVIG_4:
	CLR	R7
	
	LDI	R24,4
SD1:
	LSL	R9
	ROL	R8
	ROL	R7
	
	DEC	R24
	BRNE	SD1
	
	RET
;************************************************
SDVIG_8:
	LDI	R24,8
SD9:
	ROL	R0
	ROL	R19
	ROL	R18
	ROL	R17
	ROL	R16

	DEC	R24
	BRNE	SD9
	
	RET
;************************************************
;   80    80  
;             80 
; R0...R9-MNOGIMOE,R10...R19-MNOGITEL,R20...R29-RAB
; R0...R9-RESULT
; R20...R29-RESULT
; ZL(R30)-TEMP
;************************************************
MULT:
	CLT		;   ,         
	
	LDI	ZL,80		;   
		
	CLR	R20
	CLR	R21
	CLR	R22
	CLR	R23
	CLR	R24
	CLR	R25
	CLR	R26
	CLR	R27
	CLR	R28
	CLR	R29		;   
OBRAT:
	LSR	R10
	ROR	R11
	ROR	R12
	ROR	R13
	ROR	R14
	ROR	R15
	ROR	R16
	ROR	R17
	ROR	R18
	ROR	R19		;       ,
	BRCC	NO_SUMMIR	; =0  
SUMMIR:
					; =1      
	ADD	R29,R9
	ADC	R28,R8
	ADC	R27,R7
	ADC	R26,R6
	ADC	R25,R5
	ADC	R24,R4
	ADC	R23,R3
	ADC	R22,R2
	ADC	R21,R1
	ADC	R20,R0
	BRLT	ERROR_MULT	; S- 
	BRCS	ERROR_MULT
NO_SUMMIR:
	LSL	R9
	ROL	R8
	ROL	R7
	ROL	R6
	ROL	R5
	ROL	R4
	ROL	R3
	ROL	R2
	ROL	R1
	ROL	R0		; *2

	DEC	ZL
	BRNE	OBRAT

	MOV	R0,R20
	MOV	R1,R21
	MOV	R2,R22
	MOV	R3,R23
	MOV	R4,R24
	MOV	R5,R25
	MOV	R6,R26
	MOV	R7,R27
	MOV	R8,R28
	MOV	R9,R29
		
	RET
		
ERROR_MULT:
	SET
	RET
;**********************************************************************
;   78    78  
; R0...R9-,  R10...R19-!!!!R0...R9-
; R20...R29-,ZL-TEMP, ZH-ZERO
;**********************************************************************
GDIV_ERROR:
	SET
GDIV_OUT2:
	RET
DIV:
	CLT		;   ,        
 		
	CLR	ZH	; zero-

	CLR	R20
	CLR	R21
	CLR	R22
	CLR	R23
	CLR	R24
	CLR	R25
	CLR	R26
	CLR	R27
	CLR	R28
	CLR	R29	;   
;**********************************************************************
;       
	TST	R0
	BRMI	GDIV_ERROR	;  , ERROR
		
	CP	R19,R29
	CPC	R18,R28
	CPC	R17,R27
	CPC	R16,R26
	CPC	R15,R25
	CPC	R14,R24
	CPC	R13,R23
	CPC	R12,R22
	CPC	R11,R21
	CPC	R10,R20
	BREQ	GDIV_ERROR	; YES,DELITEL=0, ERROR

	CP	R29,R9
	CPC	R28,R8
	CPC	R27,R7
	CPC	R26,R6
	CPC	R25,R5
	CPC	R24,R4
	CPC	R23,R3
	CPC	R22,R2
	CPC	R21,R1
	CPC	R20,R0
	BREQ	GDIV_OUT2	; YES,DELIMOE=0, REZULTAT=0

	CP	R9,R19
	CPC	R8,R18
	CPC	R7,R17
	CPC	R6,R16
	CPC	R5,R15
	CPC	R4,R14
	CPC	R3,R13
	CPC	R2,R12
	CPC	R1,R11
	CPC	R0,R10
	BRPL	DIV_GO1		; NO, DELITEL<DELIMOGO
	RJMP	DIV_OUT1
DIV_GO1:
	BRNE	DIV_GO
	RJMP	DIV_EQU		; =, =1
;***************************************************************************
;     
;***************************************************************************
DIV_GO:
	CLR	ZL		;   
DIV1:
	CP	R19,R9
	CPC	R18,R8
	CPC	R17,R7
	CPC	R16,R6
	CPC	R15,R5
	CPC	R14,R4
	CPC	R13,R3
	CPC	R12,R2
	CPC	R11,R1
	CPC	R10,R0
	BRCC	DIV2		; YES,DELITEL>DELIMOGO
      		
	LSL	R19
	ROL	R18
	ROL	R17
	ROL	R16
	ROL	R15
	ROL	R14
	ROL	R13
	ROL	R12
	ROL	R11
	ROL	R10		; DELITEL*2
		
	INC	ZL
	CPI	ZL,80
	BRNE	DIV1
;***************************************************************************
;     
;***************************************************************************
DIV2:
T_DIV0:
	CLT
		
	LSL	R9
	ROL	R8
	ROL	R7
	ROL	R6
	ROL	R5
	ROL	R4
	ROL	R3
	ROL	R2
	ROL	R1
	ROL	R0		;   *2

	CP	R19,R9
	CPC	R18,R8
	CPC	R17,R7
	CPC	R16,R6
	CPC	R15,R5
	CPC	R14,R4
	CPC	R13,R3
	CPC	R12,R2
	CPC	R11,R1
	CPC	R10,R0		;    ?
	BRCS	T_DIV20		; ,  0   
		
	SET			; ,   1   
T_DIV20:
	ROL	R29
	ROL	R28
	ROL	R27
	ROL	R26
	ROL	R25
	ROL	R24
	ROL	R23
	ROL	R22
	ROL	R21
	ROL	R20
	BRTS	T_DIV40

	SUB	R9,R19
	SBC	R8,R18
	SBC	R7,R17
	SBC	R6,R16
	SBC	R5,R15
	SBC	R4,R14
	SBC	R3,R13
	SBC	R2,R12
	SBC	R1,R11
	SBC	R0,R10
T_DIV40:
	DEC	ZL
	BRNE	T_DIV0
;***************************************************************************
;     
DIV_OUT:
	LSL	R9
	ROL	R8
	ROL	R7
	ROL	R6
	ROL	R5
	ROL	R4
	ROL	R3
	ROL	R2
	ROL	R1
	ROL	R0		; *2  0.*2

	CP	R9,R19
	CPC	R8,R18
	CPC	R7,R17
	CPC	R6,R16
	CPC	R5,R15
	CPC	R4,R14
	CPC	R3,R13
	CPC	R2,R12
	CPC	R1,R11
	CPC	R0,R10		;      >0.5 ?
	BRCS	DIV_OUT1	; ,  <0.5
				;   > 0.5,  1
;***************************************************************************
DIV_EQU:		
	SEC
		
	ADC	R29,ZH		
	ADC	R28,ZH		
	ADC	R27,ZH		
	ADC	R26,ZH		
	ADC	R25,ZH		
	ADC	R24,ZH		
	ADC	R23,ZH		
	ADC	R22,ZH		
	ADC	R21,ZH		
	ADC	R20,ZH		
DIV_OUT1:		
	MOV	R0,R20
	MOV	R1,R21
	MOV	R2,R22
	MOV	R3,R23
	MOV	R4,R24
	MOV	R5,R25
	MOV	R6,R26
	MOV	R7,R27
	MOV	R8,R28
	MOV	R9,R29

	CLT
	RET
;**********************************************************************
;       UMUP
; http://electronix.ru/forum/index.php?s=&showtopic=10934&view=findpost&p=324208
;**********************************************************************
BIN_BCD:
	CLR	R25		; BCD OUT 1'000'000'000,100'000'000
	CLR	R26		; BCD OUT 10'000'000,1'000'000
	CLR	R27		; BCD OUT 100'000,10'000
	CLR	R28		; BCD OUT 1'000,100
	CLR	R29		; BCD OUT 10,1

	LDI	R24,32
bin32bcd10:
	subi r29,-0x33	;add 0x33
	sbrs r29, 3	;if carry to bit 3
	subi r29, 3	;subtract 3
	sbrs r29, 7	;if carry to bit 7
	subi r29, 0x30	;subtract 0x30

	subi r28,-0x33      ; \n" /*add 0x33*/
	sbrs r28, 3         ; \n" /*if carry to bit 3,*/
	subi r28, 3         ; \n" /*subtract 3*/
	sbrs r28, 7         ; \n" /*if carry to bit 7,*/
	subi r28, 0x30      ; \n" /*subtract 0x30*/

	subi r27,-0x33       ;\n" /*add 0x33*/
	sbrs r27, 3          ;\n" /*if carry to bit 3,*/
	subi r27, 3          ;\n" /*subtract 3*/
	sbrs r27, 7          ;\n" /*if carry to bit 7,*/
	subi r27, 0x30       ;\n" /*subtract 0x30*/

	subi r26,-0x33       ;\n" /*add 0x33*/
	sbrs r26, 3          ;\n" /*if carry to bit 3,*/
	subi r26, 3          ;\n" /*subtract 3*/
	sbrs r26, 7          ;\n" /*if carry to bit 7,*/
	subi r26, 0x30       ;\n" /*subtract 0x30*/

	subi r25,-0x33       ;\n" /*add 0x33*/
	sbrs r25, 3          ;\n" /*if carry to bit 3,*/
	subi r25, 3          ;\n" /*subtract 3*/
	sbrs r25, 7          ;\n" /*if carry to bit 7,*/
	subi r25, 0x30       ;\n" /*subtract 0x30*/

	lsl r29
	rol r28
	rol r27
	rol r26		; \n" /*shift out buffer*/
	rol r25
   
	sbrc R6, 7	;skip if msbit of input =0*/
	ori  R29, 1        ;set lsb of output*/

	lsl R9
	rol R8
	rol R7		;shift input*/
	rol R6
   
	dec R24		;\n"
	brne bin32bcd10	;repeat for all bits*/

	MOV	R5,R25
	MOV	R6,R26
	MOV	R7,R27
	MOV	R8,R28
	MOV	R9,R29

	RET
;************************************************
CLEAR_R64:
	
	LDI	R21,$40
	RJMP	CLEAR0
CLEAR_R10:
	LDI	R21,10
CLEAR0:
	
	clr ZH		;	+++++++++++++++++++++++ 

	CLR	R20
	ST	Z+,R20
	DEC	R21
	BRNE	CLEAR0

	RET
;***************************************************************************
;	 R21 -   DIAPAZON_E7


BAND:
	LDI	R20,$01		;    C
	SBIS	PIND,1
	LDI	R20,$04		;    R
	ldi R21,$04		;    R  E7

BAND_GO:
	
	STS	DIAPAZON,R20
	sts DIAPAZON_E7, R21		;+++++++++++++04/05/2013

BAND_R:

	LDI	ZL,$0A
	RCALL	CLEAR_R10	;   R10...R19
	
E7_1:
	ldi	R22,$25		;     7
	ldi	R23,$38		;   9525

; , ,    ,  9528,   7
	cp	R9,R23
	cpc	R8,R22
	cpc	R7,R17
	cpc	R6,R16
	cpc	R5,R15
	cpc	R4,R14
	cpc	R3,R13
	cpc	R2,R12
	cpc	R1,R11
	cpc	R0,R10
	brcs	END_E7	; ,  R9...0 ,  R23...10

	lds	R21,DIAPAZON_E7
	inc	R21
	sts DIAPAZON_E7, R21		;+++++++++++++25/05/2013

END_E7:
		
	LDI	R18,$27
	LDI	R19,$0B		;   9'995
	
	CP	R9,R19
	CPC	R8,R18
	CPC	R7,R17
	CPC	R6,R16
	CPC	R5,R15
	CPC	R4,R14
	CPC	R3,R13
	CPC	R2,R12
	CPC	R1,R11
	CPC	R0,R10
	BRCS	BAND_OUT	; ,  R9...0 ,  R19...10
	

	LDI	ZL,$0A
	RCALL	CLEAR_R10	;   R10...R19
	LDI	R19,10		;  10
	RCALL	DIV

	LDS	R20,DIAPAZON
	INC	R20
	STS	DIAPAZON,R20
	CPI	R20,11
	BRCS	BAND_R
BAND_OUT:
	RET
;************************************************
T_E24:
	.dw	 1048,1148,1248,1395,1548,1695,1895,2095
	.dw	 2295,2543,2843,3143,3443,3743,4090,4490
	.dw	 4890,5338,5885,6485,7133,7833,8628,9528

BAND_E24:
 
 	clr R20		;  
		
	LDI	ZL,$0A
	RCALL	CLEAR_R10	;   R10...R19
			
; +++++++++++++++  R9...r0 -  Rx,  R19...R10 -   	
E24_1:				;
	mov R21, R0		;  R0
		
	sts	DIAPAZON_E24,R20		;      RAM
	lsl R20				;       2
	
	mov YL, R20			;      
	ldi YH, 0			;
	
	ldi ZL, LOW(T_E24*2)	;   Z   
	ldi	ZH, HIGH(T_E24*2)
	
	add ZL, YL			;      ( +)
	adc ZH, YH			;

	lpm					;   R0     Z
	mov R19, R0
	inc ZL
	lpm 				;   R0     Z+1
	mov R18, R0
	mov R0, R21			;  R0

	CP	R9,R19		;   10- 
	CPC	R8,R18
	CPC	R7,R17
	CPC	R6,R16
	CPC	R5,R15
	CPC	R4,R14
	CPC	R3,R13
	CPC	R2,R12
	CPC	R1,R11
	CPC	R0,R10
	BRCS	E24_OUT	;   ,  R9...0  ,  R19...10
	

	lds	R20,DIAPAZON_E24	;
	inc	R20
		
	CPI	R20,24			; 
	BRCS	E24_1		;   R20    24
	
	clr R20					;       
	sts	DIAPAZON_E24,R20	;

E24_OUT:

	ret
;************************************************


;************************************************
OUT_PORT_A:		;   PORTA   7  24

	push R21
	push R20

	;    (V_OK=1) 
	lds R20,V_OK
	cpi R20,0
	breq outa_1
	
;	lds	R20,DIAPAZON_E7	;   PORTA   7  24
	lds	R20,DS_E7	;   PORTA   7  24 ----------------------------
	subi R20,4

	lsl R20			;   7   
	lsl R20
	lsl R20
	lsl R20
	lsl R20

;	lds	R21,DIAPAZON_E24
	lds	R21,DS_E24 ;  -----------------------------------
	add R20,R21			;   24
	out	PORTA,R20		;  7  24   

outa_1:
	pop R20
	pop R21

	ret


OUT_PORT_C:	;  R20 - 0,1,2    DD_123
					;  R21 - 7   V_24(0), 6- V_7(0), 5- (1)

	push R24
	push R23
	push R22
	push R21
	push R20

	lds	R20,DD_123	;   R20   
	com R20
	
; 1.  V_OK (   )
	
	lds R21,V_OK
	cpi R21,0
	brne alt_1		; ,  
	
	lds R21,MODE	;   LED   1
	cpi R21,1
	brne alt_0

	ldi R21, 0b00011111
	out PORTC,R21
	rjmp alt_10
	 
alt_0:
	ldi R21, 0b11011111
	out PORTC,R21
	rjmp alt_10

alt_1:
; 2.      Cx          
	
	lds	R21,REGIM 
	cpi R21,$02
	brne alt_2
	ldi R21,0b11011000		; 
	add R21,R20
	out PORTC,R21
	rjmp alt_10

alt_2:
; 3.      Rx  
	
	lds R21,MODE
	cpi R21,0
	brne alt_3 
	ldi R21,0b00011000
	add R21,R20
	out PORTC,R21
	rjmp alt_10
	
alt_3:
; 4.      Rx   
	
	ldi R21,0b00111000
	add R21,R20
	out PORTC,R21

alt_10:	
		
	pop R20
	pop R21
	pop R22
	pop R23
	pop R24

	ret




;*************************************************

BEEP_STOP:
	
	;  ,  ,  ,  
;	ldi R23, 0b11110111
;	add R22,R23
;	LDI	R22,$C0		; OVER_T1+OCR1A+CAPT
;	OUT	TIMSK,R22	;  CAPT
;	OUT	TIFR,R22	;  FLAG's OVER_T1, FLAG_ICP
;	sei
;	cli
	in R22,TIMSK
	andi R22, 0b01111111
	out TIMSK,R22

	rcall BEEP_ON
	rcall DELAY_025s
	rcall BEEP_OFF
	rcall DELAY_1s
;	rcall DELAY_1s

;	LDI	R22,$C8		; OVER_T1+OCR1A+CAPT
;	OUT	TIMSK,R22	;  
;	
	out	TIMSK,R22
	ret
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%13
;%%%%%%%%%%%%%%%%   %%%%%%%%%%%%%%%%%%%%%%%%%%13

DELAY_01s:

	push R20
	push R19
	push R18
	push R17

	ldi R20,06	;  05     (20,5 *5=0,1 )
de_1:			; (  R20   0 - 12 0
	dec R20
	breq de_4

	ldi R19,64		;| 320mks *64= 20,5ms
de_2:
	dec R19
	breq de_1

	ldi R18,255		;|   320 
de_3:
	ldi R17,4	;| 	
de_5:				;|
	dec R17		;|
	brne de_5	;|

	dec R18
	brne de_3		;|   320 
	rjmp de_2

	
de_4:

	pop R17
	pop R18
	pop R19
	pop R20

	ret

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%13

DELAY_025s:

	push R20
	push R19
	push R18
	push R17

	ldi R20,12	;  13     (20,5 *12=0,247 )
d_1:			; (  R20   0 - 12 0
	dec R20
	breq d_4

	ldi R19,64		;| 320mks *64= 20,5ms
d_2:
	dec R19
	breq d_1

	ldi R18,255		;|   320 
d_3:
	ldi R17,4	;| 	
d_5:				;|
	dec R17		;|
	brne d_5	;|

	dec R18
	brne d_3		;|   320 
	rjmp d_2


d_4:
	pop R17
	pop R18
	pop R19
	pop R20
	
	ret

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%13

DELAY_1s:
	push R16
	ldi R16,5	; 
dd_1:
	dec R16
	breq dd_2
	rcall DELAY_025s
	rjmp dd_1
dd_2:
	pop R16
		
	ret

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%13

TEST_LED:	;    %%%%%%%%%%%%%%%%%%%%%%%%%%13
			; ++++++++++++++++++++     
	clr R16
	clr R17
	ldi R17,0b00011000	;    LED,    (1+2+3),   (PORTC.5)
	out PORTC, R17		; 

	ldi R20,5			;  5     LED
wt1:
	dec R20
	breq wt4

	ldi R19,255
wt2:
	dec R19
	breq wt1
; ++++++++++++++  +++++++++++
	out PORTA,R16		;
	inc R16
; +++++++++++++++   ++++++++

	ldi R18,255		;|   320 
wt3:
	ldi R17,4	;| 	
wt5:			;|
	dec R17		;|
	brne wt5	;|
	dec R18
	brne wt3		;|   320 
	rjmp wt2
wt4:
						;    
	ldi R17,0b11011111	;  ,   ,  
	out PORTC, R17		;

	ret 
; +++++++++++++++++++++++++++   LED ++++++++++++++++++++++++
; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



BEEP_ON:
	push R17
	ldi R17,0b11111111	;  ,   ,  
	out PORTC, R17		;
	pop R17
	ret

BEEP_OFF:
	push R17
	ldi R17,0b11011111	;  ,   ,  
	out PORTC, R17		;
	pop R17
	ret
	


;*************************************************
RABOTA:
	CLR	XH
	CLR	XL		;   1=0 

	CLR	R22
	CLR	R23
	CLR	YH
	CLR	YL		;  Nx=0
	
	CLR	R24		;   

	CLT

	LDI	R20,$C8		; OVER_T1+OCR1A+CAPT
	OUT	TIMSK,R20	; 
	OUT	TIFR,R20	;  FLAG's OVER_T1, FLAG_ICP
	
	OUT	GIMSK,ZH	;   INT0,INT1

	SEI
WAIT:
;	SLEEP
	BRTC	WAIT
	CLI
W_IND:
	LDI	R20,$40		; OCR1A
	OUT	TIMSK,R20	;  OCR1A
	OUT	GIMSK,R20	;  INT0
	
	SER	R20
	OUT	TIFR,R20	;  FLAG's OVER_T1, FLAG_ICP
	OUT	GIFR,R20

	CLT
	SEI
WAIT_IND:
;	SLEEP
	BRTC	WAIT_IND	;    
	CLI
	CLT
;***************************************************************************
	CPI	XH,10   ; 
;	CPI	XH,11   ;  
	BRCS	RAB_OUT
	SER	R20		; 
	STS	RAM_PEREGRUZKA,R20
RAB_OUT:
; $70...$79- nx
; $80...$89- Nx
	RET
;************************************************
CONV:
	COM	R9
	COM	R8
	COM	R7
	COM	R6
	COM	R5
	COM	R4
	COM	R3
	COM	R2
	COM	R1
	COM	R0

	LDI	R20,1
	ADD	R9,R20
	ADC	R8,ZH
	ADC	R7,ZH
	ADC	R6,ZH
	ADC	R5,ZH
	ADC	R4,ZH
	ADC	R3,ZH
	ADC	R2,ZH
	ADC	R1,ZH
	ADC	R0,ZH

	RET
;************************************************
;************************************************
;************************************************
;************************************************
CAPT:
	SBRC	R24,7
	RJMP	CAPT_1
	SBR	R24,$80		;   
	
	IN	R11,ICR1L
	IN	R10,ICR1H
	CLR	XH
	CLR	XL		;    nx_begin
		
	RETI
CAPT_1:
	ADIW	YL,1		; Nx=Nx+1
	ADC	R23,ZH								;	???????????????????????????
	ADC	R22,ZH								;	???????????????????????????
		
	CPI	XL,50		;   ?
	CPC	XH,ZH
	BRCC	CAPT_2		; 
	RETI			; 
CAPT_2:
	IN	R9,ICR1L
	IN	R8,ICR1H	;   nx

	SUB	R9,R11    ; R9=R9-R11
	SBC	R8,R10    ; R8=R8-R9-C
	SBC	XL,ZH
	SBC	XH,ZH		  ; nx-nx_begin
		
	STS	$76,XH    ; $76^=XH^
	STS	$77,XL    ; ..
	STS	$78,R8
	STS	$79,R9		; nx
		
	STS	$86,R22
	STS	$87,R23
	STS	$88,YH
	STS	$89,YL		;Nx
		
	SET
	RETI
;***************************************************************************
;***************************************************************************
;***************************************************************************
;*************************************************************** 
TIMER_COMP1:
;29.01.2012
;	SEI
	push R22

;***************************************************************************
;27.01.2012			     
	IN	R20,PIND
	ANDI	R20,$02
	LDS	R21,REGIM
	CPSE	R20,R21
	
	RJMP	START
	
	SEI
;***************************************************************************
	LDI	R20,$FF
	LDI	R21,$43
	OUT	PORTB,R20	;    
	OUT	PORTD,R21	;  
	
	
	
	
	
	clr ZH		;	>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


	LDI	ZL,LOW(DC_ANODE*2)
	LDS	R20,ANODE
	ADD	ZL,R20
	LPM

	LDI	ZL,IND100	;   ZL  IND100
	ADD	ZL,R20
	LD	R21,Z		;      R21
	
;%%%%%%%%%%%%%%%%%  , /    %%%%%%%%%%%%%%%%13	
	cli
	lds R22,V_OK
;	ldi R22,1			;  
	cpi R22,1			;  ?  
	breq tc_1			;   , (V_OK=1),    
	ldi R21,0b11111111	;    
	sei
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%13

tc_1:
;	clr R22
;	sts V_OK,R22
	
	OUT	PORTD,R0
	OUT	PORTB,R21	;   
	
	INC	R20
	ANDI	R20,$03		;     
	STS	ANODE,R20
	
	IN	R21,OCR1AL
	IN	R20,OCR1AH
	
	LDI	R18,HIGH(16433)
	LDI	R19,LOW(16433)

	ADD	R21,R19
	ADC	R20,R18
	
	OUT	OCR1AH,R20
	OUT	OCR1AL,R21	;    OCR1A   

	pop R22

	RETI

;*************************************************
;*************************************************
;	END

VERIFY:
	
;	push R24
;	push R23
;	push R22
	push R21
	push R20
	cli


	lds R20,REGIM 		; ,    ?
	cpi R20,$02			; REGIM: Cx-$02, Rx-$00
	breq ver_5			;  ,    




	lds R20,MODE		; ,    ?
	cpi R20,0
	breq ver_6			;   (MODE=0), 

	


	lds R20,DIAPAZON_E24	; 
	lds R21,DS_E24
	cp R20,R21
	brne ver_7

	lds R20,DIAPAZON_E7		; 
	lds R21,DS_E7
	cp R20,R21
	brne ver_7

	lds R20,N_VER
	inc R20
	sts N_VER,R20
	cpi R20,5				;  3 ?
	breq ver_8				; ,  
	rjmp ver_4				;   
	
ver_7: 	
	lds R21,DIAPAZON_E7		;   
	sts DS_E7,R21
	lds R21,DIAPAZON_E24
	sts DS_E24,R21
	clr R20
	sts N_VER,R20			;  
	rjmp ver_4


ver_5:					;     
	ldi R20,1			;     ,  , LED  ,  , 
	sts V_OK,R20
	sts RAZM,R20	
	
	clr R20
	sts ZUMM,R20
	sts V_LED,R20
	rjmp ver_10

ver_6:					;      Rx
	ldi R20,1			;  ,  , LED ,   
	sts V_OK,R20
	sts V_LED,R20
	sts RAZM,R20
	
	clr R20
	sts ZUMM,R20
	rjmp ver_10

ver_4:					;     
	clr R20			;   R   , LED  ,   ,   
	sts V_LED,R20
	sts RAZM,R20
	sts V_OK,R20
	sts ZUMM,R20
	rjmp ver_11

ver_8:					;      
	ldi R20,1			;   R  , LED  ,  ,  
	sts V_OK,R20
	sts ZUMM,R20
	sts V_LED,R20
	sts RAZM,R20

	clr R20				;  
	sts n_VER,R20
ver_10:

	lds R21,DIAPAZON_E7		;        
	sts DS_E7,R21
	lds R21,DIAPAZON_E24
	sts DS_E24,R21

ver_11:
	sei
	pop R20
	pop R21
;	pop R22
;	pop R23
;	pop R24
	
	reti
